Library ieee;
Use IEEE.Std_Logic_1164.All;

Entity Scankey4_4 is
Port( clk : in std_logic;
	  col : in std_logic_vector(3 downto 0);
	  row : out std_logic_vector(3 downto 0);
	  data : out std_logic_vector(3 downto 0);
 	  rd : out std_logic	
	);
End Scankey4_4;

Architecture RTL of Scankey4_4 is
signal row_data : std_logic_vector(3 downto 0);
begin
	row <= row_data;
	Process(clk)
	variable count : integer range 0 to 3 ;
	begin
	  if (clk'EVENT) and (clk = '1') then
	    if count <= 3 then
		  count := count + 1;
		else
		  count := 0;
		end if;
		
		case count is
		  when 0 =>
			row_data <= "1110";   
		  when 1 =>
			row_data <= "1101";			    
		  when 2 =>
			row_data <= "1011";
		  when 3 =>
			row_data <= "0111";
		end case;
	  end if;
	end Process;

	process(clk,col)
    begin
	  if (clk'EVENT) and (clk = '1') then
		case row_data is
		  when "1110" =>
			case col is
			  when "1110" => data <= "0000"; rd <='0'; --0
			  when "1101" => data <= "0001"; rd <='0'; --1
			  when "1011" => data <= "0010"; rd <='0'; --2
			  when "0111" => data <= "0011"; rd <='0'; --3
			  when others => rd <= '1';
			end case;
			
		  when "1101" =>
			case col is
			  when "1110" => data <= "0100"; rd <= '0'; --4
			  when "1101" => data <= "0101"; rd <= '0'; --5
			  when "1011" => data <= "0110"; rd <= '0'; --6
			  when "0111" => data <= "0111"; rd <= '0'; --7
			  when others => rd <= '1';
			end case;

		  when "1011" =>
			case col is
			  when "1110" => data <= "1000"; rd <= '0'; --8
			  when "1101" => data <= "1001"; rd <= '0'; --9
			  when "1011" => data <= "1010"; rd <= '0'; --10
			  when "0111" => data <= "1011"; rd <= '0'; --11
			  when others => rd <= '1';
			end case;

		  when "0111" =>
			case col is
			  when "1110" => data <= "1100"; rd <= '0'; --12
			  when "1101" => data <= "1101"; rd <= '0'; --13
			  when "1011" => data <= "1110"; rd <= '0'; --14		
			  when "0111" => data <= "1111"; rd <= '0'; --15
			  when others => rd <= '1';
			end case;
		  
		  when others => 
			rd <= '1';
		end case;
	  end if;
	end process;
end RTL;
